/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageOrderDetailsDiscount type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageOrderDetailsDiscount{}

// MessageOrderDetailsDiscount struct for MessageOrderDetailsDiscount
type MessageOrderDetailsDiscount struct {
	Amount string `json:"amount"`
	Description *string `json:"description,omitempty"`
	ProgramName *string `json:"program_name,omitempty"`
}

// NewMessageOrderDetailsDiscount instantiates a new MessageOrderDetailsDiscount object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageOrderDetailsDiscount(amount string) *MessageOrderDetailsDiscount {
	this := MessageOrderDetailsDiscount{}
	this.Amount = amount
	return &this
}

// NewMessageOrderDetailsDiscountWithDefaults instantiates a new MessageOrderDetailsDiscount object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageOrderDetailsDiscountWithDefaults() *MessageOrderDetailsDiscount {
	this := MessageOrderDetailsDiscount{}
	return &this
}

// GetAmount returns the Amount field value
func (o *MessageOrderDetailsDiscount) GetAmount() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Amount
}

// GetAmountOk returns a tuple with the Amount field value
// and a boolean to check if the value has been set.
func (o *MessageOrderDetailsDiscount) GetAmountOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Amount, true
}

// SetAmount sets field value
func (o *MessageOrderDetailsDiscount) SetAmount(v string) {
	o.Amount = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *MessageOrderDetailsDiscount) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageOrderDetailsDiscount) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *MessageOrderDetailsDiscount) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *MessageOrderDetailsDiscount) SetDescription(v string) {
	o.Description = &v
}

// GetProgramName returns the ProgramName field value if set, zero value otherwise.
func (o *MessageOrderDetailsDiscount) GetProgramName() string {
	if o == nil || IsNil(o.ProgramName) {
		var ret string
		return ret
	}
	return *o.ProgramName
}

// GetProgramNameOk returns a tuple with the ProgramName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageOrderDetailsDiscount) GetProgramNameOk() (*string, bool) {
	if o == nil || IsNil(o.ProgramName) {
		return nil, false
	}
	return o.ProgramName, true
}

// HasProgramName returns a boolean if a field has been set.
func (o *MessageOrderDetailsDiscount) HasProgramName() bool {
	if o != nil && !IsNil(o.ProgramName) {
		return true
	}

	return false
}

// SetProgramName gets a reference to the given string and assigns it to the ProgramName field.
func (o *MessageOrderDetailsDiscount) SetProgramName(v string) {
	o.ProgramName = &v
}

func (o MessageOrderDetailsDiscount) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageOrderDetailsDiscount) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["amount"] = o.Amount
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	if !IsNil(o.ProgramName) {
		toSerialize["program_name"] = o.ProgramName
	}
	return toSerialize, nil
}

type NullableMessageOrderDetailsDiscount struct {
	value *MessageOrderDetailsDiscount
	isSet bool
}

func (v NullableMessageOrderDetailsDiscount) Get() *MessageOrderDetailsDiscount {
	return v.value
}

func (v *NullableMessageOrderDetailsDiscount) Set(val *MessageOrderDetailsDiscount) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageOrderDetailsDiscount) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageOrderDetailsDiscount) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageOrderDetailsDiscount(val *MessageOrderDetailsDiscount) *NullableMessageOrderDetailsDiscount {
	return &NullableMessageOrderDetailsDiscount{value: val, isSet: true}
}

func (v NullableMessageOrderDetailsDiscount) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageOrderDetailsDiscount) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


